import { ChangeDetectorRef, OnChanges, OnDestroy, OnInit, SimpleChanges, ViewContainerRef } from '@angular/core';
import { Subject } from 'rxjs';
import { INgxBindIOConfig } from '../interfaces/ngx-bind-io-config.interface';
import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
import { NgxBindInputsService } from '../services/ngx-bind-inputs.service';
import { NgxBindIODebugService } from '../services/ngx-bind-io-debug.service';
import { NgxBindOutputsService } from '../services/ngx-bind-outputs.service';
export declare class BindIODirective implements INgxBindIODirective, OnChanges, OnInit, OnDestroy {
    viewContainerRef: ViewContainerRef;
    private _ngxBindIOConfig;
    private _ngxBindInputsService;
    private _ngxBindOutputsService;
    private _ngxBindIODebugService;
    private _detectorRef;
    bindIO: INgxBindIOConfig | undefined;
    excludeIO: string[] | string;
    includeIO: string[] | string;
    excludeInputs: string[] | string;
    includeInputs: string[] | string;
    excludeOutputs: string[] | string;
    includeOutputs: string[] | string;
    innerComponent: any;
    hostComponent: any;
    inputs: {
        innerKeys: string[];
        hostKeys: string[];
    };
    outputs: {
        innerKeys: string[];
        hostKeys: string[];
    };
    usedInputs: {
        [key: string]: string;
    };
    usedOutputs: {
        [key: string]: string;
    };
    destroyed$: Subject<boolean>;
    innerSimpleChanges: SimpleChanges;
    ignoreKeysManualBinded: boolean;
    constructor(viewContainerRef: ViewContainerRef, _ngxBindIOConfig: INgxBindIOConfig, _ngxBindInputsService: NgxBindInputsService, _ngxBindOutputsService: NgxBindOutputsService, _ngxBindIODebugService: NgxBindIODebugService, _detectorRef: ChangeDetectorRef);
    ngOnChanges(simpleChanges: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    bindValue(innerKey: string, value: any): void;
    bindAll(): void;
    detectComponents(): void;
    debugIsActive(): boolean;
}
