import { ChangeDetectorRef, OnChanges, OnDestroy, OnInit, SimpleChanges, ViewContainerRef } from '@angular/core';
import { Subject } from 'rxjs';
import { INgxBindIOConfig } from '../interfaces/ngx-bind-io-config.interface';
import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
import { NgxBindIODebugService } from '../services/ngx-bind-io-debug.service';
import { NgxBindOutputsService } from '../services/ngx-bind-outputs.service';
export declare class BindOutputsDirective implements Partial<INgxBindIODirective>, OnChanges, OnInit, OnDestroy {
    viewContainerRef: ViewContainerRef;
    private _ngxBindIOConfig;
    private _ngxBindOutputsService;
    private _ngxBindIODebugService;
    private _ref;
    bindOutputs: INgxBindIOConfig | undefined;
    excludeOutputs: string[] | string;
    includeOutputs: string[] | string;
    innerComponent: any;
    hostComponent: any;
    outputs: {
        innerKeys: string[];
        hostKeys: string[];
    };
    usedOutputs: {
        [key: string]: string;
    };
    destroyed$: Subject<boolean>;
    constructor(viewContainerRef: ViewContainerRef, _ngxBindIOConfig: INgxBindIOConfig, _ngxBindOutputsService: NgxBindOutputsService, _ngxBindIODebugService: NgxBindIODebugService, _ref: ChangeDetectorRef);
    ngOnChanges(simpleChanges: SimpleChanges): void;
    ngOnInit(): void;
    bindAll(): void;
    ngOnDestroy(): void;
    detectComponents(): void;
    debugIsActive(): boolean;
}
