import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
export declare class NgxBindInputsService {
    /**
     * BindInputs Directive
     */
    bindInputs(directive: Partial<INgxBindIODirective>): void;
    bindObservableInputs(directive: Partial<INgxBindIODirective>): void;
    /**
     * Inputs
     */
    checkKeyNameToInputBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    checkInputToBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    bindInput(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): void;
    /**
     * Observable Inputs
     */
    checkKeyNameToObservableInputBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    checkObservableInputToBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    bindObservableInput(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): void;
    /**
     * Utils
     */
    getInputs(directive: Partial<INgxBindIODirective>): {
        hostKeys: string[];
        innerKeys: string[];
    };
    getIncludesAndExcludes(directive: Partial<INgxBindIODirective>): {
        includeInputs: string[];
        excludeInputs: string[];
    };
}
