import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
export declare class NgxBindOutputsService {
    /**
     * BindOutputs Directive
     */
    bindOutputs(directive: Partial<INgxBindIODirective>): void;
    /**
     * Outputs
     */
    checkKeyNameToOutputBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    checkOutputToBind(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): boolean;
    bindOutput(directive: Partial<INgxBindIODirective>, hostKey: string, innerKey: string): void;
    /**
     * Utils
     */
    getOutputs(directive: Partial<INgxBindIODirective>): {
        hostKeys: string[];
        innerKeys: string[];
    };
    getIncludesAndExcludes(directive: Partial<INgxBindIODirective>): {
        includeOutputs: string[];
        excludeOutputs: string[];
    };
}
